SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0;
SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0;
SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='TRADITIONAL';

CREATE SCHEMA IF NOT EXISTS `gradessecurity` DEFAULT CHARACTER SET latin1 COLLATE latin1_swedish_ci ;
USE `gradessecurity` ;

-- -----------------------------------------------------
-- Table `gradessecurity`.`grade_security`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `gradessecurity`.`grade_security` ;

CREATE  TABLE IF NOT EXISTS `gradessecurity`.`grade_security` (
  `idGradeSecurity` INT(10) NOT NULL AUTO_INCREMENT ,
  `itemId` INT(10) UNSIGNED NOT NULL ,
  `itemName` VARCHAR(255) NULL ,
  `courseId` INT(10) UNSIGNED NOT NULL ,
  `userId` INT(10) NOT NULL ,
  `userFirstName` VARCHAR(100) NOT NULL ,
  `userLastName` VARCHAR(100) NOT NULL ,
  `finalGrade` DECIMAL(10,5) NULL ,
  `userModified` INT(10) UNSIGNED NULL ,
  `gradeTimeModified` BIGINT(10) UNSIGNED NOT NULL ,
  `itemType` VARCHAR(30) NULL ,
  `hmac` VARCHAR(100) NOT NULL ,
  `flagConsistency` TINYINT(1) NOT NULL DEFAULT 0 ,
  PRIMARY KEY (`idGradeSecurity`) )
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `gradessecurity`.`user_name`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `gradessecurity`.`user_name` ;

CREATE  TABLE IF NOT EXISTS `gradessecurity`.`user_name` (
  `userId` INT(10) UNSIGNED NOT NULL ,
  `firstName` VARCHAR(100) NOT NULL ,
  `lastName` VARCHAR(100) NOT NULL ,
  `email` VARCHAR(100) NOT NULL ,
  PRIMARY KEY (`userId`) )
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `gradessecurity`.`log_grade_security`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `gradessecurity`.`log_grade_security` ;

CREATE  TABLE IF NOT EXISTS `gradessecurity`.`log_grade_security` (
  `id_log_grade_security` INT(10) NOT NULL AUTO_INCREMENT ,
  `idGradeSecurity` INT(10) NOT NULL ,
  `itemId` INT(10) UNSIGNED NOT NULL ,
  `courseId` INT(10) UNSIGNED NOT NULL ,
  `userId` INT(10) NOT NULL ,
  `finalGrade` DECIMAL(10,5) NULL ,
  `userModified` INT(10) UNSIGNED NULL ,
  `gradeTimeModified` BIGINT(10) UNSIGNED NOT NULL ,
  `timeCreated` BIGINT(10) UNSIGNED NOT NULL ,
  `type` ENUM('Inconsistencia', 'Resolucion de Inconsistencia') NULL ,
  PRIMARY KEY (`id_log_grade_security`) ,
  INDEX `idGradeSecurity` (`idGradeSecurity` ASC) ,
  CONSTRAINT `idGradeSecurity`
    FOREIGN KEY (`idGradeSecurity` )
    REFERENCES `gradessecurity`.`grade_security` (`idGradeSecurity` )
    ON DELETE NO ACTION
    ON UPDATE NO ACTION)
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `gradessecurity`.`course_name`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `gradessecurity`.`course_name` ;

CREATE  TABLE IF NOT EXISTS `gradessecurity`.`course_name` (
  `courseId` INT(10) NOT NULL ,
  `courseName` VARCHAR(254) NOT NULL ,
  PRIMARY KEY (`courseId`) )
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `gradessecurity`.`user_oncharge_course`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `gradessecurity`.`user_oncharge_course` ;

CREATE  TABLE IF NOT EXISTS `gradessecurity`.`user_oncharge_course` (
  `userId` INT(10) UNSIGNED NOT NULL ,
  `courseId` INT(10) NOT NULL ,
  PRIMARY KEY (`userId`, `courseId`) ,
  INDEX `fk_grade_user_oncharge_has_course_name_course_name1` (`courseId` ASC) ,
  INDEX `fk_grade_user_oncharge_has_course_name_grade_user_oncharge1` (`userId` ASC) ,
  CONSTRAINT `fk_grade_user_oncharge_has_course_name_grade_user_oncharge1`
    FOREIGN KEY (`userId` )
    REFERENCES `gradessecurity`.`user_name` (`userId` )
    ON DELETE NO ACTION
    ON UPDATE NO ACTION,
  CONSTRAINT `fk_grade_user_oncharge_has_course_name_course_name1`
    FOREIGN KEY (`courseId` )
    REFERENCES `gradessecurity`.`course_name` (`courseId` )
    ON DELETE NO ACTION
    ON UPDATE NO ACTION)
ENGINE = InnoDB;



SET SQL_MODE=@OLD_SQL_MODE;
SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS;
SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS;
